@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    var sondages = ViewData["Sondages"] as List<AuthnData.Classes.Sondages>;
    var invtations = ViewData["Invitations"] as List<AuthnData.Classes.InvitedUsers>; // Liste des invitations pour le User
    var invitedSondages = ViewData["InvtedInSondage"] as List<AuthnData.Classes.Sondages>; // List des sondages aux quels le user a été invité
    ViewData["Title"] = "Accueil";
}


<h1>Mes Sondages</h1>
<hr>

<table class="table  table-bordered table-darkened custom-size" >
        <thead>
            @* <tr class="custom-size">
                <td class="custom-size" id="thead-question" style="width: 70%;">Quéstion posée</td>
                <td class="custom-size" id="thead-edit-link" style="width: 5%;">Éditer</td>
                <td class="custom-size" id="thead-finish-link" style="width: 5% ;">Clotturer</td>
                <td class="custom-size" id="thead-consult-link" style="width: 5%;">Résultats</td>
            </tr> *@
            <colgroup>
                <col class="custom-size" id="thead-question" >
                <col class="custom-size" id="thead-share-link" >
                <col class="custom-size" id="thead-edit-link" >
                <col class="custom-size" id="thead-finish-link" >
                <col class="custom-size" id="thead-consult-link" >
            </colgroup>
            @* <colgroup>
                <col class="custom-size" id="thead-question" style="width: 70%;">Quéstion posée</col>
                <col class="custom-size" id="thead-edit-link" style="width: 10%;">Éditer</col>
                <col class="custom-size" id="thead-finish-link" style="width: 10% ;">Clotturer</col>
                <col class="custom-size" id="thead-consult-link" style="width: 10%;">Résultats</col>
            </colgroup> *@
        </thead>
        @{int i = new int();}
    @{  foreach (AuthnData.Classes.Sondages sondage in sondages)
        {
            var message = new {number=i++};
        <tr class="custom-size">

            <td class="custom-size thead-question">@sondage.Question</td>

            <td class="custom-size thead-share-link">
                <button  class="btn btn-primary colored-buttons"  data-bs-container="body" data-bs-toggle='popover' data-bs-placement="left" title="Partage du sondage" data-content-id="popInvite_@(i)" data-bs-content="Vous permet de mettre s'inviter de nouvelles personnes à répondre à votre sondage">
                    <a class="white-text percent-size-full" data-bs-toggle="modal" data-bs-target="#modalInvite" onclick="setModalInviteLink('@sondage.viewToken')">
                        <i class="fas fa-user-plus"></i>
                    </a>
                </button>

            <td class="custom-size thead-edit-link">
                <button type="submit" class="btn btn-primary colored-buttons" data-bs-container="body" data-bs-toggle='popover' data-bs-placement="left" title="Édition du sondage" data-content-id="popEdit_@(i)"  data-bs-content="vous pouvez modifier votre sondage ici">
                    <a class="white-text percent-size-full not-a-link" asp-controller="Sondage" asp-action="Edit" asp-route-token="@sondage.viewToken">
                        <i class="white-text fas fa-pencil-alt"></i>
                    </a>
                </button>
            </td>

            <td class="custom-size thead-finish-link">
                @if (sondage.isClosed != 1)
                {
                <button  class="btn btn-primary colored-buttons"  data-bs-container="body" data-bs-toggle='popover' data-bs-placement="left" title="Désactivation du sondage" data-content-id="popFinish_@(i)" data-bs-content="Vous permet de mettre fin à la possibilité de voter ou changer son vote">
                    <a class="white-text percent-size-full" data-bs-toggle="modal" data-bs-target="#modalFinish" onclick="setModalFinishLink('@sondage.closeToken')">
                        <i class="fas fa-times"></i>
                    </a>
                </button>
                }
            </td>

            <td class="custom-size thead-consult-link">
                <button type="button" class="btn btn-primary colored-buttons" data-bs-container="body" data-bs-toggle='popover' data-bs-placement="left" title="Consultation des résultats" data-content-id="popResults_@(i)"  data-bs-content="Vous pouvez obtenir les résultats du sondage ici">
                    <a class="white-text percent-size-full not-a-link" asp-controller="Sondage" asp-action="ViewResult" asp-route-token="@sondage.publicToken">
                        <i class="white-text fas fa-search"></i>
                    </a>
                </button>
            </td>
        </tr>
        }
     }
</table>
<table class="table  table-bordered table-darkened custom-size" >
    <tr>
        <td>
            <a class="btn btn-primary" id="colored-button" asp-controller="Sondage" asp-action="Create">Créer mon Sondage</a>
        </td>
    </tr>
</table>

<table class="table  table-bordered table-darkened custom-size" >
    <colgroup>
                <col class="custom-size" id="thead-question" >
                <col class="custom-size" id="thead-share-link" >
    </colgroup>
    @foreach(var invitedSondage in invitedSondages)
    {
        <tr>
            <td>@invitedSondage.Question</td>
            <td>
                <button type="button" class="btn btn-primary colored-buttons" data-bs-container="body" data-bs-toggle='popover' data-bs-placement="left" title="Voter/Conulter" data-content-id="popResults_@invitedSondage.Id"  data-bs-content="Vous pouvez voter à ce sondage">
                    <a class="percent-size-full not-a-link" asp-controller="Sondage" asp-action="ViewSondage" asp-route-token="@invitedSondage.viewToken">
                        <i class="white-text fas fa-vote-yea"></i>
                    </a>
                </button>
            </td>
        </tr>
    }
</table>

@* MODAL pour la desactivation du sondage *@
<div class="modal fade" id="modalFinish" tabindex="-1" aria-labelledby="finish-modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="finish-modal">Cloturer le sondage</h5>
                <button type="button" class="close-modal-btn" data-bs-dismiss="modal" aria-label="Close"><i class="fas fa-times"></i></button>
            </div>
            <div class="modal-body">
                <div>
                    Attention, une fois fermer aucun nouveau vote ne pourra être effectuer sur votre sondage mais les résultats seront toujours consultable. Voulez-vous continuer ?
                </div>
            </div>
            <div class="modal-footer">
                <form asp-controller="Sondage" asp-action="CloseSondage" method="post">
                    <input type="hidden" name="token" id="finishModalLink" value="" />
                    <input type="hidden" name="nothing" value="" />
                    <input type="submit" class="btn btn-danger" value="Oui" />
                </form>
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Annuler</button>
                @* <a type="submit" class="btn btn-danger not-a-link" id="finishModalLink" asp-controller="Sondage" asp-action="CloseSondage" asp-route-token="">Cloturer</a> *@
            </div>
        </div>

    </div>
</div>


@* MODAL pour inviter les gens au sondage *@
<div class="modal fade" id="modalInvite" tabindex="-1" aria-labelledby="invite-modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="invite-modal">Inviter les utilisateurs au sondage</h5>
                <button type="button" class="close-modal-btn" data-bs-dismiss="modal" aria-label="Close"><i class="fas fa-times"></i></button>
            </div>
            <div class="modal-body">
                <div class="informativ-message">
                    <p>Vous pouvez inviter des gens à participer au sondage.</p>
                    <p>Vous devez dabords saisir une adresse mail valide et l'ajouter à la liste des adresses à envoyer</p>
                </div>
                <div>
                    <form asp-controller="Sondage" asp-action="InviteToSondage" id="submiteForm" method="post">
                        <input type="hidden" id="inviteModalLink" name="token" value="x"/>
                        <label for="addmail" class="label-form">Ajouter une adresse E-mail</label>
                        <div class="add-mail-div">
                            <input type="email" id="addmail" name="addmail" class="form-control add-mail-input" placeholder="mail@mail.com" />
                            <i class="fa fa-plus i-colored add-mail-i" id="addemail" name="addemail" onclick="AddInput()"></i>
                        </div>
                        <br />
                        <div id="email" name="email">
                        </div>
                        <button type="button" class="btn colored-buttons" value="Inviter par mail" onclick="submitInviteForm()">Inviter par mail</button>
                    </form>
                </div>
            </div>
            <script type="text/javascript">
            var emailNum = 0;
                function AddInput() {
                    if (ValidateEmail()) {
                            // count the total of emails
                        emailNum++;

                            // create receiving div to contain input and close button
                        var newStructure = document.createElement('div');
                        newStructure.className = "email-input-div";
                        newStructure.id = 'emailDiv_'+emailNum;

                            // create new input for the mail
                        var newInput = document.createElement('input');
                        newInput.type = "text";
                        newInput.name = "emails";
                        newInput.readOnly = true;
                        newInput.className = "form-control";

                            // create the close button and link to the remove function
                        var closeButton = document.createElement('a');
                        closeButton.className = "close-button";
                        var closeButtonIcon = document.createElement('i');
                        closeButtonIcon.className = "fas fa-times";
                        closeButton.appendChild(closeButtonIcon);

                        closeButton.addEventListener("click", () => { removeInput(newStructure.id);}, false);

                            // add the newly made container to the emails div
                        var monForm = document.getElementById("email");
                        monForm.appendChild(newStructure);
                        newStructure.appendChild(closeButton);
                        newStructure.appendChild(newInput);

                        newInput.value = document.getElementById("addmail").value;

                        document.getElementById("addmail").value = "";

                        return true
                    } else {
                        console.log("Email isn't valid");
                        return false
                    }
                }

                function ValidateEmail() 
                {
                    @* console.log(document.getElementById('addmail').value); *@
                    let testedString = document.getElementById('addmail').value;
                    if (/^\w+([\.-]?\w+)*@@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(testedString))
                    {
                        return (true)
                    }
                    alert("Vous devez entrer une adresse mail valide!")
                    return (false)
                }

                function removeInput(divId) 
                {
                    emailNum--;
                    var el = document.getElementById(divId);
                    console.log('removed ele: '+ divId);
                    el.remove();
                }

                function submitInviteForm() 
                {
                    // if the imput is not empty
                    let tempString = document.querySelectorAll('#addmail')[0].value;
                    if (tempString != "") {
                        if (ValidateEmail()) {
                            AddInput();
                            let myInviteForm = document.querySelectorAll('#submiteForm');
                            myInviteForm[0].submit();
                            return true;
                        } else {
                            console.log('tried to add the content of the input but failed');
                            return false;
                        }
                    } else {
                        if (checkIfCanSubmit()) {
                            let myInviteForm = document.querySelectorAll('#submiteForm');
                            myInviteForm[0].submit();
                            return true;
                        } else {
                            console.log('you can\'t submit an empty form');
                            return false;
                        }
                    }
                }

                function checkIfCanSubmit() 
                {
                    let emailDivs = document.querySelectorAll('.email-input-div');
                    if (emailDivs[0]) {
                        return true;
                    } else {
                        return false;
                    }
                }

            </script>
        </div>
    </div>
</div>



<script>
          @* console.log("ontouchstart : " + touchDevice) *@
          @* console.log("screen orientation : "+screen.orientation) *@


var inviteModal = new bootstrap.Modal(document.getElementById('modalInvite'));
var finishModal = new bootstrap.Modal(document.getElementById('modalFinish'));

function setModalFinishLink(closeToken) {
    var modalLink = document.getElementById('finishModalLink');
    @* console.log('trying to update modal link to '+closeToken+' \n on:'+modalLink) *@
    modalLink.value = closeToken;
}

function setModalInviteLink(viewToken) {
    var modalLink = document.getElementById("inviteModalLink");
    @* console.log('trying to update modal link to '+viewToken+' \n on:'+modalLink); *@
    modalLink.value = viewToken;
}

var isPopDisplayed = null;

popcheck();
window.onresize = popcheck();
Window.ondeviceorientation = popcheck();

function popcheck() 
{
    var touchDevice = ('ontouchstart' in document.documentElement);
    if (!touchDevice) {
        addPopovers();
    } else {
        removePopovers();
    }
};

function addPopovers() {
    if (!isPopDisplayed) {
        isPopDisplayed = true;
        console.log('addpops');
        var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
        var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
            const popoverId = popoverTriggerEl.attributes['data-content-id'];
            if (popoverId) {
                const contentEl = popoverTriggerEl.attributes['data-bs-content'].value;
                const titleEl = popoverTriggerEl.attributes['title'].value;
                return new bootstrap.Popover(popoverTriggerEl, {
                    html: true,
                    title: '<span>' + titleEl + '</span>',
                    content: '<span class="popContent">' + contentEl + '</span>',
                    trigger: "hover",
                });
            }else{//do something else cause data-content-id isn't there.
            }
        })
    }
};

function removePopovers() {
    if (isPopDisplayed) {
        isPopDisplayed = false;
        console.log('removepops');
        var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
        var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
                console.log('find what pop i need: '+popoverTriggerEl.value);
                @* .popover('destroy'); *@
        })
    }
};


@* var myModal = new bootstrap.Modal(document.getElementById('modalFinish')) *@
</script>

